plugins {
    id("org.jetbrains.kotlin.multiplatform")
    id("application")
}

kotlin {
    targets {
        jvm()
    }

    sourceSets {
        val commonMain by getting {
            dependencies {
                implementation(Deps.kotlinx.coroutines.common)
                implementation(project(":repository"))
            }
        }

        val commonTest by getting {
            dependencies {
                Deps.kotlin.test.common.forEach { implementation(it) }
            }
        }

        val jvmMain by getting {
            dependencies {
                implementation(Deps.kotlinx.coroutines.jvm)
                implementation(Deps.kotlinx.coroutines.javafx)
                implementation(Deps.tornadofx)
            }
        }

        val jvmTest by getting {
            dependencies {
                implementation(Deps.kotlin.test.jvm)
            }
        }
    }
}

//jar {
//    manifest {
//        attributes(
//                "Class-Path": configurations.compile.collect { it.getName() }.join(" "),
//        "Main-Class": mainClassName
//        )
//    }
//    from(configurations.compile.collect { entry -> zipTree(entry) }) {
//        exclude "META-INF/MANIFEST.MF"
//        exclude "META-INF/*.SF"
//        exclude "META-INF/*.DSA"
//        exclude "META-INF/*.RSA"
//    }
//}
