package dev.scottpierce.mobiletest

import javafx.beans.property.SimpleIntegerProperty
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.GlobalScope
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import tornadofx.*

class MainView : View("Hello TornadoFX") {
    val model: MainViewModel by inject()

    override val root = vbox {
        label(title)
    }
}

class MainViewModel : ViewModel() {
    val count = SimpleIntegerProperty(0)

    init {
        GlobalScope.launch(Dispatchers.Main) {
            for (i in 0..1000) {
                delay(1000)
                count.value = count.value + 1
            }
        }
    }
}