import org.gradle.kotlin.dsl.accessors.warnAboutDiscontinuedJsonProjectSchema

plugins {
    id("org.jetbrains.kotlin.multiplatform")
}

kotlin {
    targets {
        jvm()
        js {
            binaries.executable()
            nodejs()
        }
    }

    sourceSets {
        val commonMain by getting {
            dependencies {
                implementation(Deps.kotlinx.coroutines.common)
            }
        }

        val commonTest by getting {
            dependencies {
                Deps.kotlin.test.common.forEach { implementation(it) }
            }
        }

        val jvmMain by getting {
            dependencies {
                implementation(Deps.kotlinx.coroutines.jvm)
                implementation(Deps.okio)
            }
        }

        val jvmTest by getting {
            dependencies {
                implementation(Deps.kotlin.test.jvm)
            }
        }

        val jsMain by getting {
            dependencies {
                implementation(Deps.kotlinx.coroutines.js)
                implementation(Deps.kotlinx.nodejs)
            }
        }

        val jsTest by getting {
            dependencies {
                implementation(Deps.kotlin.test.js)
                implementation(Deps.kotlinx.coroutines.js)
            }
        }
    }
}

//class JNAeratorTask : DefaultTask() {
//    // private static final Logger LOG = LoggerFactory.getLogger(JNAeratorTask.class);
//    @OutputDirectory
//    private var outputDir: File? = null
//
//    // LOG.info("setLibraryName: " + libraryName);
//    @get:Input
//    var libraryName: String? = null
//
//    @get:Input
//    var packageName: String? = null
//
//    // LOG.info("getHeaderFiles = " + headerFiles);
//    @get:InputFiles
//    var headerFiles: FileCollection? = null
//        private set
//
//    @get:Input
//    var runtimeMode: JNAeratorConfig.Runtime = JNAeratorConfig.Runtime.JNA
//
//    @Input
//    private val define: MutableSet<String> = HashSet()
//
//    @Input
//    private val undefine: MutableSet<String> = HashSet()
//
//    @Input
//    private var extraArgs: MutableList<String?> = mutableListOf()
//
//    @OutputDirectory
//    fun getOutputDir(): File? {
//        logger
//        return outputDir
//    }
//
//    fun setOutputDir(@javax.annotation.Nonnull outputDir: Any?) {
//        this.outputDir = project.file(outputDir)
//    }
//
//    fun outputDir(@javax.annotation.Nonnull outputDir: Any?) {
//        setOutputDir(outputDir)
//    }
//
//    fun libraryName(@javax.annotation.Nonnull libraryName: String?) {
//        this.libraryName = libraryName
//    }
//
//    fun packageName(@javax.annotation.Nonnull packageName: String?) {
//        this.packageName = packageName
//    }
//
//    fun setHeaderFiles(@javax.annotation.Nonnull vararg headerFiles: Any?) {
//        // LOG.info("setHeaderFiles = " + headerFiles);
//        this.headerFiles = project.files(*headerFiles)
//    }
//
//    fun headerFiles(vararg headerFiles: Any) {
//        setHeaderFiles(*headerFiles)
//    }
//
//    fun runtimeMode(runtimeMode: Any) {
//        this.runtimeMode = if (runtimeMode is JNAeratorConfig.Runtime) runtimeMode
//        else JNAeratorConfig.Runtime.valueOf(runtimeMode.toString())
//    }
//
//    fun define(vararg args: Any) {
//        for (arg in args) define.add(arg.toString())
//    }
//
//    fun undefine(vararg args: Any) {
//        for (arg in args) undefine.add(arg.toString())
//    }
//
//    @javax.annotation.Nonnull
//    fun getExtraArgs(): List<String?> {
//        return extraArgs
//    }
//
//    fun setExtraArgs(@javax.annotation.Nonnull extraArgs: MutableList<String?>) {
//        this.extraArgs = extraArgs
//    }
//
//    fun extraArgs(@javax.annotation.Nonnull vararg extraArgs: Any) {
//        for (arg in extraArgs) this.extraArgs.add(arg.toString())
//    }
//
//    @TaskAction
//    fun run() {
//        val args: MutableList<String?> = ArrayList()
//        args.add(JNAeratorCommandLineArgs.OptionDef.CurrentLibrary.clSwitch)
//        args.add(libraryName)
//        args.add(JNAeratorCommandLineArgs.OptionDef.CurrentPackage.clSwitch)
//        args.add(packageName)
//        for (file in headerFiles!!) args.add(file.absolutePath)
//        args.add(JNAeratorCommandLineArgs.OptionDef.OutputMode.clSwitch)
//        args.add(JNAeratorConfig.OutputMode.Directory.name)
//        args.add(JNAeratorCommandLineArgs.OptionDef.Runtime.clSwitch)
//        args.add(runtimeMode.name)
//        args.add(JNAeratorCommandLineArgs.OptionDef.OutputDir.clSwitch)
//        // String outputPath = getPackageName().replace('.', File.separatorChar);
//        // File outputDir = new File(getOutputDir(), outputPath);
//        args.add(getOutputDir()!!.absolutePath)
//        args.add(JNAeratorCommandLineArgs.OptionDef.ForceOverwrite.clSwitch)
//        // args.add(JNAeratorCommandLineArgs.OptionDef.Verbose.clSwitch);
//        args.add("-v")
//        for (d in define) args.add("-D$d")
//        for (u in undefine) args.add("-U$u")
//        args.addAll(getExtraArgs())
//        org.codehaus.groovy.runtime.DefaultGroovyMethods.deleteDir(outputDir)
//        outputDir!!.mkdirs()
//        logger.info("Invoking jnaerator $args")
//        JNAerator.main(args.toTypedArray())
//    }
//}
