package dev.scottpierce.mobiletest.repository

import kotlinx.coroutines.*

abstract class Repository {
    companion object {
        internal val scope = CoroutineScope(SupervisorJob()) + NonCancellable
    }

    internal suspend fun <T> withRepositoryContext(block: suspend CoroutineScope.() -> T): T {
        return withContext(scope.coroutineContext, block)
    }
}
