package dev.scottpierce.mobiletest.repository.data

import kotlinx.coroutines.flow.Flow

internal interface DataSource {
    suspend fun getConnectedDevices(): List<ConnectedDevice>
    suspend fun getDeviceInfo(id: String): Map<String, String>
    suspend fun streamSystemLog(id: String): Flow<String>
}

data class ConnectedDevice(
    val id: String,
    val type: String
)